package serial;

import java.io.InputStream;
import java.io.OutputStream;
import java.net.URI;
import java.net.http.HttpClient;
import java.net.http.WebSocket;
import java.util.concurrent.CountDownLatch;

public class ProcessRFID 
{
	private InputStream in;
	private OutputStream out;
	private CountDownLatch latch;
	private WebSocket ws;
								
	//									흰색 카드		파란 카드, 	
	public static String[] RFIDs = { "97A8B64E", "C799FF32"}; 
	
	public ProcessRFID(InputStream in, OutputStream out) 
	{
		this.in = in;
		this.out = out;
		latch = new CountDownLatch(10);	//	데이터를 10번만 받겠다는 의미
		URI uri = URI.create("ws://localhost:9090/websocket"); 
		//	WebsocketClientArduino 클래스의 onText함수가 호출이 된다.
		WebsocketClientArduino listener = new WebsocketClientArduino( this.latch, this.out );
		
		ws = HttpClient.newHttpClient().newWebSocketBuilder().buildAsync(
				uri, listener).join();
	}
	
	//	파란 카드이면 true를, 흰색 카드이면 false를 리턴
	public static boolean IsMatchedBlueCard(String receivedData)
	{
		if ( RFIDs[0].equals(receivedData) )
			return false;
		else
			return true;
	}
	
	public static boolean IsMatchedRFID(String receivedData)
	{
		boolean ret = false;
		
		for ( String s : RFIDs)
		{
			if ( s.equals(receivedData))
			{
				ret = true;
				break;
			}
		}
		return ret;
	}
	
	private String GetCardInfo(String receivedData)
	{
		String ret = "";
		
		if (receivedData.equals(RFIDs[0]))
			ret = "흰색카드";
		else if (receivedData.equals(RFIDs[1]))
			ret = "파란카드";
		else
			ret = "정의되지않음";
		
		return ret;
	}
	
	public void SendReceivedDataToWebSocket(String receivedData)
	{
        System.out.println("카드 유형 : " +this.GetCardInfo(receivedData));
        
        ws.sendText(receivedData, true);
	}
}