package serial;
import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;

public class SerialRead implements Runnable
{
	InputStream in;
	private OutputStream out;
	
	boolean dataReceiveOk = false;
	boolean dataReceiveComplete = false;
	String receivedData = "";
	
	public SerialRead(InputStream in, OutputStream out)
	{
		this.in = in;
		this.out = out;
	}
	
	@Override
	public void run() 
	{
		byte[] buffer = new byte[1024];
		int len = -1;
		
		try {
			String s = "";
			//	buffer에 저장하고나서, 그 길이를 반환한다.
			while ((len = this.in.read(buffer)) > -1)
			{
				s = new String( buffer, 0, len );
				
				if ( s.length() == 0 && this.dataReceiveOk == true )
					this.dataReceiveComplete = true;
				
				if ( s.length() > 0 && this.dataReceiveComplete == false ) 
				{
					receivedData += s;
					this.dataReceiveOk = true;
				}
				else if ( this.dataReceiveComplete )
				{
					System.out.println("receivedData : " +this.receivedData);
					
					//	읽은 데이터가 카드정보이면, 카드 정보를 웹 서버에 전송
					if ( ProcessRFID.IsMatchedRFID(this.receivedData) )
					{
						System.out.println("카드 정보 입니다.");
						(new ProcessRFID(in, out)).SendReceivedDataToWebSocket(receivedData);
					}

					//	정보 초기화
					this.receivedData = "";
					this.dataReceiveComplete = false;
					this.dataReceiveOk = false;
				}
			}
		} 
		catch (IOException e) {e.printStackTrace();}
	}
}